// WARNING: generated by kopium - manual changes will be overwritten
// kopium command: kopium -f ciliumendpoints.yml --schema=derived --docs -b --derive=Default --derive=PartialEq --smart-derive-elision
// kopium version: 0.21.1

#[allow(unused_imports)]
mod prelude {
    pub use kube_derive::CustomResource;
    #[cfg(feature = "schemars")]
    pub use schemars::JsonSchema;
    pub use serde::{Deserialize, Serialize};
    pub use std::collections::BTreeMap;
    #[cfg(feature = "builder")]
    pub use typed_builder::TypedBuilder;
}
use self::prelude::*;

/// EndpointStatus is the status of a Cilium endpoint.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatus {
    /// Controllers is the list of failing controllers for this endpoint.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub controllers: Option<Vec<CiliumEndpointStatusControllers>>,
    /// Encryption is the encryption configuration of the node
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub encryption: Option<CiliumEndpointStatusEncryption>,
    /// ExternalIdentifiers is a set of identifiers to identify the endpoint apart from the pod name. This includes container runtime IDs.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "external-identifiers"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub external_identifiers: Option<CiliumEndpointStatusExternalIdentifiers>,
    /// Health is the overall endpoint & subcomponent health.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub health: Option<CiliumEndpointStatusHealth>,
    /// ID is the cilium-agent-local ID of the endpoint.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub id: Option<i64>,
    /// Identity is the security identity associated with the endpoint
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity: Option<CiliumEndpointStatusIdentity>,
    /// Log is the list of the last few warning and error log entries
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub log: Option<Vec<CiliumEndpointStatusLog>>,
    /// NamedPorts List of named Layer 4 port and protocol pairs which will be used in Network Policy specs.
    ///  swagger:model NamedPorts
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "named-ports"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub named_ports: Option<Vec<CiliumEndpointStatusNamedPorts>>,
    /// Networking is the networking properties of the endpoint.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub networking: Option<CiliumEndpointStatusNetworking>,
    /// EndpointPolicy represents the endpoint's policy by listing all allowed ingress and egress identities in combination with L4 port and protocol.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub policy: Option<CiliumEndpointStatusPolicy>,
    /// State is the state of the endpoint.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub state: Option<CiliumEndpointStatusState>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "visibility-policy-status"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub visibility_policy_status: Option<String>,
}

/// ControllerStatus is the status of a failing controller.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusControllers {
    /// Configuration is the controller configuration
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub configuration: Option<CiliumEndpointStatusControllersConfiguration>,
    /// Name is the name of the controller
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub name: Option<String>,
    /// Status is the status of the controller
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub status: Option<CiliumEndpointStatusControllersStatus>,
    /// UUID is the UUID of the controller
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub uuid: Option<String>,
}

/// Configuration is the controller configuration
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusControllersConfiguration {
    /// Retry on error
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "error-retry"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub error_retry: Option<bool>,
    /// Base error retry back-off time Format: duration
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "error-retry-base"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub error_retry_base: Option<i64>,
    /// Regular synchronization interval Format: duration
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub interval: Option<i64>,
}

/// Status is the status of the controller
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusControllersStatus {
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "consecutive-failure-count"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub consecutive_failure_count: Option<i64>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "failure-count"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub failure_count: Option<i64>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "last-failure-msg"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub last_failure_msg: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "last-failure-timestamp"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub last_failure_timestamp: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "last-success-timestamp"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub last_success_timestamp: Option<String>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "success-count"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub success_count: Option<i64>,
}

/// Encryption is the encryption configuration of the node
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusEncryption {
    /// Key is the index to the key to use for encryption or 0 if encryption is disabled.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub key: Option<i64>,
}

/// ExternalIdentifiers is a set of identifiers to identify the endpoint apart from the pod name. This includes container runtime IDs.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusExternalIdentifiers {
    /// ID assigned to this attachment by container runtime
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "cni-attachment-id"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub cni_attachment_id: Option<String>,
    /// ID assigned by container runtime (deprecated, may not be unique)
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "container-id"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub container_id: Option<String>,
    /// Name assigned to container (deprecated, may not be unique)
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "container-name"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub container_name: Option<String>,
    /// Docker endpoint ID
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "docker-endpoint-id"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub docker_endpoint_id: Option<String>,
    /// Docker network ID
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "docker-network-id"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub docker_network_id: Option<String>,
    /// K8s namespace for this endpoint (deprecated, may not be unique)
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "k8s-namespace"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub k8s_namespace: Option<String>,
    /// K8s pod name for this endpoint (deprecated, may not be unique)
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "k8s-pod-name"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub k8s_pod_name: Option<String>,
    /// K8s pod for this endpoint (deprecated, may not be unique)
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "pod-name")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub pod_name: Option<String>,
}

/// Health is the overall endpoint & subcomponent health.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusHealth {
    /// bpf
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub bpf: Option<String>,
    /// Is this endpoint reachable
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub connected: Option<bool>,
    /// overall health
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "overallHealth"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub overall_health: Option<String>,
    /// policy
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub policy: Option<String>,
}

/// Identity is the security identity associated with the endpoint
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusIdentity {
    /// ID is the numeric identity of the endpoint
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub id: Option<i64>,
    /// Labels is the list of labels associated with the identity
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub labels: Option<Vec<String>>,
}

/// EndpointStatusChange Indication of a change of status
///  swagger:model EndpointStatusChange
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusLog {
    /// Code indicate type of status change Enum: ["ok","failed"]
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub code: Option<String>,
    /// Status message
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub message: Option<String>,
    /// state
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub state: Option<String>,
    /// Timestamp when status change occurred
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub timestamp: Option<String>,
}

/// Port Layer 4 port / protocol pair
///  swagger:model Port
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusNamedPorts {
    /// Optional layer 4 port name
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub name: Option<String>,
    /// Layer 4 port number
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub port: Option<i64>,
    /// Layer 4 protocol Enum: ["TCP","UDP","SCTP","ICMP","ICMPV6","ANY"]
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub protocol: Option<String>,
}

/// Networking is the networking properties of the endpoint.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusNetworking {
    /// IP4/6 addresses assigned to this Endpoint
    #[cfg_attr(feature = "builder", builder(default))]
    pub addressing: Vec<CiliumEndpointStatusNetworkingAddressing>,
    /// NodeIP is the IP of the node the endpoint is running on. The IP must be reachable between nodes.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub node: Option<String>,
}

/// AddressPair is a pair of IPv4 and/or IPv6 address.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusNetworkingAddressing {
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub ipv4: Option<String>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub ipv6: Option<String>,
}

/// EndpointPolicy represents the endpoint's policy by listing all allowed ingress and egress identities in combination with L4 port and protocol.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusPolicy {
    /// EndpointPolicyDirection is the list of allowed identities per direction.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub egress: Option<CiliumEndpointStatusPolicyEgress>,
    /// EndpointPolicyDirection is the list of allowed identities per direction.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub ingress: Option<CiliumEndpointStatusPolicyIngress>,
}

/// EndpointPolicyDirection is the list of allowed identities per direction.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusPolicyEgress {
    /// Deprecated
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub adding: Option<Vec<CiliumEndpointStatusPolicyEgressAdding>>,
    /// AllowedIdentityList is a list of IdentityTuples that species peers that are allowed.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub allowed: Option<Vec<CiliumEndpointStatusPolicyEgressAllowed>>,
    /// DenyIdentityList is a list of IdentityTuples that species peers that are denied.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub denied: Option<Vec<CiliumEndpointStatusPolicyEgressDenied>>,
    pub enforcing: bool,
    /// Deprecated
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub removing: Option<Vec<CiliumEndpointStatusPolicyEgressRemoving>>,
    /// EndpointPolicyState defines the state of the Policy mode: "enforcing", "non-enforcing", "disabled"
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub state: Option<String>,
}

/// IdentityTuple specifies a peer by identity, destination port and protocol.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusPolicyEgressAdding {
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "dest-port")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub dest_port: Option<i64>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity: Option<i64>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "identity-labels"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity_labels: Option<BTreeMap<String, String>>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub protocol: Option<i64>,
}

/// IdentityTuple specifies a peer by identity, destination port and protocol.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusPolicyEgressAllowed {
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "dest-port")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub dest_port: Option<i64>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity: Option<i64>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "identity-labels"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity_labels: Option<BTreeMap<String, String>>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub protocol: Option<i64>,
}

/// IdentityTuple specifies a peer by identity, destination port and protocol.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusPolicyEgressDenied {
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "dest-port")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub dest_port: Option<i64>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity: Option<i64>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "identity-labels"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity_labels: Option<BTreeMap<String, String>>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub protocol: Option<i64>,
}

/// IdentityTuple specifies a peer by identity, destination port and protocol.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusPolicyEgressRemoving {
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "dest-port")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub dest_port: Option<i64>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity: Option<i64>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "identity-labels"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity_labels: Option<BTreeMap<String, String>>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub protocol: Option<i64>,
}

/// EndpointPolicyDirection is the list of allowed identities per direction.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusPolicyIngress {
    /// Deprecated
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub adding: Option<Vec<CiliumEndpointStatusPolicyIngressAdding>>,
    /// AllowedIdentityList is a list of IdentityTuples that species peers that are allowed.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub allowed: Option<Vec<CiliumEndpointStatusPolicyIngressAllowed>>,
    /// DenyIdentityList is a list of IdentityTuples that species peers that are denied.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub denied: Option<Vec<CiliumEndpointStatusPolicyIngressDenied>>,
    pub enforcing: bool,
    /// Deprecated
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub removing: Option<Vec<CiliumEndpointStatusPolicyIngressRemoving>>,
    /// EndpointPolicyState defines the state of the Policy mode: "enforcing", "non-enforcing", "disabled"
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub state: Option<String>,
}

/// IdentityTuple specifies a peer by identity, destination port and protocol.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusPolicyIngressAdding {
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "dest-port")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub dest_port: Option<i64>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity: Option<i64>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "identity-labels"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity_labels: Option<BTreeMap<String, String>>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub protocol: Option<i64>,
}

/// IdentityTuple specifies a peer by identity, destination port and protocol.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusPolicyIngressAllowed {
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "dest-port")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub dest_port: Option<i64>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity: Option<i64>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "identity-labels"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity_labels: Option<BTreeMap<String, String>>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub protocol: Option<i64>,
}

/// IdentityTuple specifies a peer by identity, destination port and protocol.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusPolicyIngressDenied {
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "dest-port")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub dest_port: Option<i64>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity: Option<i64>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "identity-labels"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity_labels: Option<BTreeMap<String, String>>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub protocol: Option<i64>,
}

/// IdentityTuple specifies a peer by identity, destination port and protocol.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct CiliumEndpointStatusPolicyIngressRemoving {
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "dest-port")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub dest_port: Option<i64>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity: Option<i64>,
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "identity-labels"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub identity_labels: Option<BTreeMap<String, String>>,
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub protocol: Option<i64>,
}

/// EndpointStatus is the status of a Cilium endpoint.
#[derive(Serialize, Deserialize, Clone, Debug, PartialEq)]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub enum CiliumEndpointStatusState {
    #[serde(rename = "creating")]
    Creating,
    #[serde(rename = "waiting-for-identity")]
    WaitingForIdentity,
    #[serde(rename = "not-ready")]
    NotReady,
    #[serde(rename = "waiting-to-regenerate")]
    WaitingToRegenerate,
    #[serde(rename = "regenerating")]
    Regenerating,
    #[serde(rename = "restoring")]
    Restoring,
    #[serde(rename = "ready")]
    Ready,
    #[serde(rename = "disconnecting")]
    Disconnecting,
    #[serde(rename = "disconnected")]
    Disconnected,
    #[serde(rename = "invalid")]
    Invalid,
}
